/* io_submit
 */
#define NO_SYSCALL_ERRNO
#include <lib_io.h>
#include <asm/unistd.h>
#include <asm/errno.h>
#include <stdlib.h>

struct timespec;
static inline _syscall4(long, __io_getevents, io_context_t, ctx, int, nr, struct io_event *, events, struct timespec *,timeout)

long io_queue_run(io_context_t ctx)
{
	struct io_event event;
	int ret;

	while (1 == (ret = __io_getevents(ctx, 1, &event, NULL))) {
		io_callback_t cb = (io_callback_t)event.obj;
		struct iocb *iocb = (struct iocb *)event.data;

		cb(ctx, iocb, event.res, event.res2);
	}

	return ret;
}
