/* io_queue_init.c
 */
#define NO_SYSCALL_ERRNO
#include <asm/unistd.h>
#include <lib_io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

static inline _syscall2(long, __io_setup, unsigned, nr_reqs, io_context_t *, ctxp);


long io_queue_init(int maxevents, io_context_t *ctxp)
{
	if (maxevents <= 0)
		return -EINVAL;
	return __io_setup(maxevents, ctxp);
}
